package wx_app

import (
	"fmt"
	wechat "github.com/silenceper/wechat/v2"
	"github.com/silenceper/wechat/v2/cache"
	"github.com/silenceper/wechat/v2/miniprogram"
	"github.com/silenceper/wechat/v2/miniprogram/auth"
	"github.com/silenceper/wechat/v2/miniprogram/config"
	"github.com/silenceper/wechat/v2/miniprogram/encryptor"
)

//微信小程序配置信息
var (
	WxId        string //微信原始ID
	WxAppId     string
	WxAppSecret string
	WxPlatform  int //用户来源，需要入库，用来保存该用户来自哪个平台，默认是：1
)

func init() {
	WxAppId = `wxb059c872d79b9967`
	WxId = `gh_75abb562a946`
	WxAppSecret = `1737c73e9f69a21de1a345b8f0800258`
	WxPlatform = 6 //弘则研报来源
}

func GetWxApp() (miniprogram *miniprogram.MiniProgram) {
	wc := wechat.NewWechat()
	memory := cache.NewMemory()
	//memory := cache.NewRedis(global.Redis)
	cfg := &config.Config{
		AppID:     WxAppId,
		AppSecret: WxAppSecret,
		Cache:     memory,
	}

	miniprogram = wc.GetMiniProgram(cfg)
	return
}

// GetSession 获取用户详情
func GetSession(code string) (userInfo auth.ResCode2Session, err error) {
	wechatClient := GetWxApp()
	authClient := wechatClient.GetAuth()
	userInfo, err = authClient.Code2Session(code)
	return
}

// GetSession 获取用户详情
func GetUserInfo(code string) (userInfo auth.ResCode2Session, err error) {
	wechatClient := GetWxApp()
	authClient := wechatClient.GetAuth()
	fmt.Println("code:", code)
	userInfo, err = authClient.Code2Session(code)
	return
}

// 获取解密信息 GetDecryptInfo
func GetDecryptInfo(sessionKey, encryptedData, iv string) (decryptData *encryptor.PlainData, err error) {
	wechatClient := GetWxApp()
	encryptorClient := wechatClient.GetEncryptor()
	decryptData, err = encryptorClient.Decrypt(sessionKey, encryptedData, iv)
	return
}

//func GetCode() {
//	codeParms := qrcode.QRCoder{
//		Page:      "",
//		Path:      "",
//		Width:     0,
//		Scene:     "",
//		AutoColor: false,
//		LineColor: qrcode.Color{},
//		IsHyaline: false,
//	}
//	//wxApp := GetWxApp()
//	//qrCode := wxApp.GetQRCode()
//	//qrCode.
//	//qrCode.GetWXACodeUnlimit()
//}
